Subject: Re: [PATCH bpf-next v3 1/4] xdp: Support specifying expected existing program when attaching XDP

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Wed, 25 Mar 2020 17:48:57 +0100

Jakub Kicinski <[email-masked]> writes:

> On Tue, 24 Mar 2020 17:54:07 -0700 Andrii Nakryiko wrote:
>> On Tue, Mar 24, 2020 at 11:13 AM Toke Høiland-Jørgensen <[email-masked]> wrote:
>> >
>> > From: Toke Høiland-Jørgensen <[email-masked]>
>> >
>> > While it is currently possible for userspace to specify that an existing
>> > XDP program should not be replaced when attaching to an interface, there is
>> > no mechanism to safely replace a specific XDP program with another.
>> >
>> > This patch adds a new netlink attribute, IFLA_XDP_EXPECTED_ID, which can be
>> > set along with IFLA_XDP_FD. If set, the kernel will check that the program
>> > currently loaded on the interface matches the expected one, and fail the
>> > operation if it does not. This corresponds to a 'cmpxchg' memory operation.
>> > Setting the new attribute with a negative value means that no program is
>> > expected to be attached, which corresponds to setting the UPDATE_IF_NOEXIST
>> > flag.
>> >
>> > A new companion flag, XDP_FLAGS_EXPECT_ID, is also added to explicitly
>> > request checking of the EXPECTED_ID attribute. This is needed for userspace
>> > to discover whether the kernel supports the new attribute.  
>> 
>> Doesn't it feel inconsistent in UAPI that FD is used to specify XDP
>> program to be attached, but ID is used to specify expected XDP
>> program? Especially that the same cgroup use case is using
>> (consistently) prog FDs. Or is it another case where XDP needs its own
>> special way?
>
> There was a comment during review of v1, I wish you spoke up then.
>
> The prog ID is what dump returns, so the consistency can go either way
> (note that this API predates object IDs). Since XDP uses IDs internally
> it's just simpler to take prog ID.
>
> But it's a detail, so if you feel strongly I don't really mind.

Using an FD instead of an ID does make this more extensible (such as
supporting bpf_link FDs in the future; see my other reply to Alexei). So
I'll respin this, and switch it back to EXPECTED_FD.

-Toke